ALTER PROCEDURE [dbo].[blacklist_up](@RET int=null OUTPUT, @UniKey int=null OUTPUT,@R int=1, 
@NUMTEL varchar(32)=NULL,
@BlackListComment varchar(64)=NULL, @SelectOrder varchar(512)=null, @pKey int=null,
@IsBlackList bit=null,
@StatCallAll int=null , @StatRefusal int=null,
@PrevStatCallAll int=null , @PrevStatRefusal int=null,
@PhoneType int=0, @isAudioRobotEnabled bit=1,
@GeoRegionFrom int=null, 
@CurrentUserUniKey int=null,
@Word1 varchar(16)=null OUTPUT)  AS
begin
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <21.03.2010>
-- Update date: <29.09.2014>
-- Description:	<   >
-- =============================================
SET DATEFORMAT dmy;
SET NOCOUNT ON
DECLARE @Q nvarchar(1024), @Key int, @KeyTmp int=null, @IsBlackListT bit,@isAudioRobotEnabledT bit;
DECLARE @PhoneCityCode varchar(10),@NumPhoneDigits int,@cPhone varchar(26), @MessageText varchar(256);
DECLARE @PhoneType1 int,@WordTmp varchar(16);

	if @R=1 /*  */
		begin
		SET @Q='SELECT bbb.*,dbo.GetClientNameByPhoneID(bbb.UniKey) ClientNames,PD.isMain as isMainDriver,GR.NameGeoRegion FROM BLACKLISTTEL bbb WITH (nolock)
			LEFT JOIN GeoRegions GR ON GR.UNIKEY=bbb.GeoRegionFrom
			LEFT JOIN PhoneDrivers PD ON bbb.UniKey=PD.PhoneKey WHERE 1=1';
--		if (@pKey is not null) SET @Q=@Q+' AND UniKey'
		if (@SelectOrder IS NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY NUMTEL';
--		RaISERROR 99999 @Q;
		Exec (@Q);
		return;
		end;
	if @R=3 /**/
		begin
		SET @UniKey=NULL;
		SELECT @UniKey=UniKey FROM BLACKLISTTEL WITH (nolock) WHERE NUMTEL=@NUMTEL
		IF (@UniKey IS NULL)
			begin
			INSERT into blacklisttel (NUMTEL,BlackListComment,IsBlackList,PhoneType,Word1,
				isAudioRobotEnabled, GeoRegionFrom, PrevStatCallAll, PrevStatRefusal)
			 VALUES (@NUMTEL,@BlackListComment,@IsBlackList,@PhoneType,@Word1,
				@isAudioRobotEnabled, @GeoRegionFrom, 
				@PrevStatCallAll, @PrevStatRefusal);
			SET @RET=SCOPE_IDENTITY();
			-- 
			if @PhoneType=2	INSERT INTO SIPWorkPlaces (isOnLine,Phone) VALUES (0,@RET);
			--  
			IF @CurrentUserUniKey IS NOT NULL
				begin
				SELECT TOP 1 @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_CREATE_BY_USER' AND LngKey IN (SELECT TOP 1 LngMain FROM PROPERTIES);
				INSERT INTO PhoneChangeLog (PhoneKey,UserUpdate,[Changes]) VALUES (@RET,@CurrentUserUniKey,
					@MessageText);
				end;
			end
			else
			begin
			SET @RET=null;
			end;
		end;
	if @R=4 /**/
		begin
		IF EXISTS(SELECT * FROM BLACKLISTTEL WITH (nolock) WHERE UniKey=@UniKey)
			begin
			DELETE FROM PhoneDiscount WHERE PhoneKey=@UniKey;
			DELETE FROM PhoneChangeLog WHERE PhoneKey=@UniKey;
			UPDATE PhoneHistory SET PhoneKey=NULL WHERE PhoneKey=@UniKey;
			UPDATE PhoneHistoryAutoRobot SET PhoneKey=NULL WHERE PhoneKey=@UniKey;
			DELETE FROM BLACKLISTTEL where UniKey=@UniKey;
			SET @RET=@UniKey;
			end
			else
			SET @RET=null;
		end;
/*       */
	if @R=5
		begin
		IF (@UniKey IS NULL)	SELECT @Key=UniKey FROM BLACKLISTTEL WITH (nolock) WHERE NUMTEL=@NUMTEL;
			ELSE SET @Key=@UniKey;
		IF @Key is null
			begin
			--   ,     
			SET @cPhone=LTRIM (@NUMTEL);
			SET @cPhone=dbo.GetPhoneInternational(@cPhone);
			SELECT @Key=UniKey FROM BLACKLISTTEL WITH (nolock) WHERE NUMTEL=@cPhone;
			end;
		IF @Key is NOT null
			begin
			SELECT TOP 1 @KeyTmp=UniKey FROM ROutesByPhone RP WHERE RP.PhoneKey=@Key;
			SELECT bbb.*,dbo.GetClientNameByPhoneID(bbb.UniKey) as ClientNames,
				isnull((SELECT COUNT(ba.UniKey) FROM BASE ba WITH (nolock) WHERE ba.PhoneKey=bbb.UniKey AND ZAKAZPLACE<100),0) as isActiveZakazCount,
				RP.StreetFrom as sStreetFrom, RP.HouseFrom  as sHouseFrom, RP.GeoRegionFrom as sGeoRegionFrom, RP.LatFrom as sLatfrom,RP.LonFrom as sLonFrom,
				RP.StreetTo as sStreetTo, RP.HouseTo  as sHouseTo, RP.GeoRegionTo as sGeoRegionTo, RP.LatTo as sLatTo,RP.LonTo as sLonTo,
				(SELECT TOP 1 PCL.CardKey FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardKey,
				(SELECT COUNT(*) FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardCount
					FROM BLACKLISTTEL bbb 
					LEFT JOIN ROutesByPhone RP ON RP.UniKey=@KeyTmp
					WHERE bbb.UniKey=@key;
			end
			else
			SELECT bbb.*,dbo.GetClientNameByPhoneID(UniKey) as ClientNames, 0 as isActiveZakazCount ,
				NULL as sStreetFrom, NULL as sHouseFrom, NULL as sGeoRegionFrom, NULL as sLatfrom,NULL as sLonFrom,
				NULL as sStreetTo, NULL  as sHouseTo, NULL as sGeoRegionTo, NULL as sLatTo,NULL as sLonTo, 0 as CardKey,
				0 as CardCount
				from BLACKLISTTEL bbb WHERE UniKey=0;
		return;
		end;
/* */
	if @R=6
		begin
		--   
		SELECT @Key=BL.PhoneType,@MessageText=BL.BlackListComment, @IsBlackListT=BL.IsBlackList,
			@isAudioRobotEnabledT=BL.isAudioRobotEnabled, @KeyTmp=BL.GeoRegionFrom,
			@WordTmp=Word1 FROM BLACKLISTTEL BL WHERE BL.UniKey=@UniKey;
			
			UPDATE BLACKLISTTEL SET BlackListComment=@BlackListComment,IsBlackList=@IsBlackList,
				PhoneType=@PhoneType,GeoRegionFrom=@GeoRegionFrom,isAudioRobotEnabled=@isAudioRobotEnabled,
				UpdateDate=GETDATE(), PrevStatCallAll=@PrevStatCallAll, PrevStatRefusal=@PrevStatRefusal
				WHERE UniKey=@UniKey;
			if @Word1 IS NOT NULL UPDATE BLACKLISTTEL SET Word1=@Word1 WHERE UniKey=@UniKey;
			-- 
			if @PhoneType=2	
				begin
				if NOT EXISTS (SELECT UniKey FROM SIPWorkPlaces WHERE Phone=@UniKey)
					INSERT INTO SIPWorkPlaces (isOnLine,Phone) VALUES (0,@UniKey);
				end
				else	DELETE FROM SIPWorkPlaces WHERE Phone=@UniKey;
		--  
		IF @CurrentUserUniKey IS NOT NULL
				begin
				if @MessageText!=@BlackListComment SET @MessageText=@BlackListComment;
					ELSE SET @MessageText='';
				IF @Key!=@PhoneType 
					SET @MessageText=@MessageText+isnull((SELECT PT.PhoneTypeName FROM PhoneTypes PT WHERE PT.UniKey=@Key),'');
				IF isnull(@KeyTmp,0)!=isnull(@GeoRegionFrom,0)
					begin
					if LEN(@MessageText)>0 SET @MessageText=@MessageText+';';
					SET @MessageText=@MessageText+isnull((SELECT GR.NameGeoRegion FROM GeoRegions GR WHERE GR.UniKey=@KeyTmp),'');
					end;

				IF @IsBlackListT!=@IsBlackList 
					begin
					if LEN(@MessageText)>0 SET @MessageText=@MessageText+';';
					SET @MessageText=@MessageText+'black list '+CAST(@IsBlackListT as varchar(16));
					end;
				IF @isAudioRobotEnabledT!=@isAudioRobotEnabled 
					begin
					if LEN(@MessageText)>0 SET @MessageText=@MessageText+';';
					SET @MessageText=@MessageText+'robot enabled='+CAST(@isAudioRobotEnabledT as varchar(16));
					end;
				IF isnull(@Word1,'')!=isnull(@WordTmp,'')
					begin
					if LEN(@MessageText)>0 SET @MessageText=@MessageText+';';
					SET @MessageText=@MessageText+'code='+@WordTmp;
					end;
				
				IF LEN(@MessageText)=0 SET @MessageText=NULL;
				INSERT INTO PhoneChangeLog (PhoneKey,UserUpdate,[Changes]) VALUES (@UniKey,@CurrentUserUniKey,
					@MessageText);
				end;
		return;
		end;
/*    */
	if @R=7
		begin
		IF NOT EXISTS(SELECT * FROM PhoneUsers WHERE PhoneKey=@UniKey AND UserKey=@pKey)
			begin
			INSERT INTO PhoneUsers (PhoneKey,UserKey) VALUES (@UniKey,@pKey);
			SET @RET=1;
			end
			else
			SET @RET=null;
		end;
/*     */
	if @R=8
		begin
		IF NOT EXISTS(SELECT * FROM PhoneLegalPersons WHERE PhoneKey=@UniKey AND LPKey=@pKey)
			begin
			INSERT INTO PhoneLegalPersons (PhoneKey,LPKey) VALUES (@UniKey,@pKey);
			SET @RET=1;
			end
			else
			SET @RET=null;
		end;
/*    */
	if @R=9
		begin
		IF NOT EXISTS(SELECT * FROM PhoneDrivers WHERE PhoneKey=@UniKey AND DriverKey=@pKey)
			begin
			INSERT INTO PhoneDrivers (PhoneKey,DriverKey) VALUES (@UniKey,@pKey);
			if NOT EXISTS(SELECT * FROM PhoneDrivers WHERE DriverKey=@pKey)
				UPDATE PhoneDrivers SET isMain=1 WHERE PhoneKey=@UniKey AND DriverKey=@pKey; 
			SET @RET=1;
			end
			else
			SET @RET=null;
		end;
/*    VIP*/
	if @R=10
		begin
		IF NOT EXISTS(SELECT * FROM PhoneVIPs WHERE PhoneKey=@UniKey AND VIPKey=@pKey)
			begin
			INSERT INTO PhoneVIPs (PhoneKey,VIPKey) VALUES (@UniKey,@pKey);
			SET @RET=1;
			end
			else
			SET @RET=null;
		end;
/*   */
	if @R=11
		begin
		DELETE FROM PhoneUsers WHERE PhoneKey=@UniKey AND UserKey=@pKey;
		end;
/*     */
	if @R=12
		begin
		DELETE FROM PhoneLegalPersons WHERE PhoneKey=@UniKey AND LPKey=@pKey;
		end;
/*   */
	if @R=13
		begin
		DELETE FROM PhoneDrivers WHERE PhoneKey=@UniKey AND DriverKey=@pKey;
		end;
/*   VIP*/
	if @R=14
		begin
		DELETE FROM PhoneVIPs WHERE PhoneKey=@UniKey AND VIPKey=@pKey;
		end;
/*   */
	if @R=15
		begin
		SELECT * FROM PhoneTypes;
		end;
/*  1 */
	if @R=16
		begin
		if @UniKey is not null
			begin
			SELECT BBB.*,PV.VIPKey,
				(SELECT TOP 1 PCL.CardKey FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardKey,
				(SELECT COUNT(*) FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardCount
				FROM BLACKLISTTEL BBB WITH (nolock) LEFT JOIN PhoneVIPs PV ON PV.PhoneKey=BBB.UniKey where UniKey=@UniKey;
			end
			else
			begin
			--   			
			SELECT @UniKey=UniKey FROM BLACKLISTTEL WITH (nolock) WHERE NUMTEL LIKE @NUMTEL
			IF @UniKey IS NULL
				begin
				SET @cPhone=[dbo].[GetPhoneInternational](@NUMTEL);
				SELECT BBB.*,PV.VIPKey,
					(SELECT TOP 1 PCL.CardKey FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardKey,
					(SELECT COUNT(*) FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardCount
					 FROM BLACKLISTTEL BBB WITH (nolock) LEFT JOIN PhoneVIPs PV ON PV.PhoneKey=BBB.UniKey where NUMTEL=@cPhone;
				end
				else
				begin
				SELECT BBB.*,PV.VIPKey,
					(SELECT TOP 1 PCL.CardKey FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardKey,
					(SELECT COUNT(*) FROM PhoneCardsLink PCL LEFT JOIN Cards C ON C.UniKey=PCL.CardKey WHERE PCL.PhoneKey=bbb.UniKey AND C.isEnabled=1) as CardCount
					FROM BLACKLISTTEL BBB WITH (nolock) LEFT JOIN PhoneVIPs PV ON PV.PhoneKey=BBB.UniKey where UniKey=@UniKey;
				end;
			end;
		return;
		end;
/*     WEB*/
	if @R=17
		begin
		DECLARE @TmpNum float;
		SET @TmpNum=RAND(@UniKey);
		SET @Word1=RIGHT(REPLACE(STR( @TmpNum,8,6),'.',''),3);		
		return;
		end;
/*    */
	if @R=18
		begin
			UPDATE PhoneDrivers SET isMain=0 WHERE PhoneKey<>@UniKey AND DriverKey=@pKey;
			UPDATE PhoneDrivers SET isMain=1 WHERE PhoneKey=@UniKey AND DriverKey=@pKey;
		return;
		end;
/*     */
	if @R=19
		begin
		SELECT UniKey,NUMTEL FROM BLACKLISTTEL WITH (nolock) WHERE UniKey>@UniKey;		
		return;
		end;
/*     */
	if @R=20
		begin
		IF NOT EXISTS(SELECT * FROM PhoneCardsLink WHERE PhoneKey=@UniKey AND CardKey=@pKey)
			begin
			INSERT INTO PhoneCardsLink (PhoneKey,CardKey) VALUES (@UniKey,@pKey);
			SET @RET=1;
			end
			else
			SET @RET=null;
		return;
		end;
/*    */
	if @R=21
		begin
		DELETE FROM PhoneCardsLink WHERE PhoneKey=@UniKey AND CardKey=@pKey;
		return;
		end;
/*     . */
	if @R=22
		begin
		SELECT PCL.*, U.FIO FROM PhoneChangeLog PCL 
			LEFT JOIN USERS U ON U.UniKey=PCL.UserUpdate
			WHERE PhoneKey= @UniKey ORDER BY PCL.DateUpdate DESC;
		return;
		end;		
end;
